// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from plansys2_msgs:msg/Derived.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "plansys2_msgs/msg/derived.hpp"


#ifndef PLANSYS2_MSGS__MSG__DETAIL__DERIVED__STRUCT_HPP_
#define PLANSYS2_MSGS__MSG__DETAIL__DERIVED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'predicate'
#include "plansys2_msgs/msg/detail/node__struct.hpp"
// Member 'preconditions'
#include "plansys2_msgs/msg/detail/tree__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__plansys2_msgs__msg__Derived __attribute__((deprecated))
#else
# define DEPRECATED__plansys2_msgs__msg__Derived __declspec(deprecated)
#endif

namespace plansys2_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Derived_
{
  using Type = Derived_<ContainerAllocator>;

  explicit Derived_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : predicate(_init),
    preconditions(_init)
  {
    (void)_init;
  }

  explicit Derived_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : predicate(_alloc, _init),
    preconditions(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _predicate_type =
    plansys2_msgs::msg::Node_<ContainerAllocator>;
  _predicate_type predicate;
  using _preconditions_type =
    plansys2_msgs::msg::Tree_<ContainerAllocator>;
  _preconditions_type preconditions;

  // setters for named parameter idiom
  Type & set__predicate(
    const plansys2_msgs::msg::Node_<ContainerAllocator> & _arg)
  {
    this->predicate = _arg;
    return *this;
  }
  Type & set__preconditions(
    const plansys2_msgs::msg::Tree_<ContainerAllocator> & _arg)
  {
    this->preconditions = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    plansys2_msgs::msg::Derived_<ContainerAllocator> *;
  using ConstRawPtr =
    const plansys2_msgs::msg::Derived_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<plansys2_msgs::msg::Derived_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<plansys2_msgs::msg::Derived_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::msg::Derived_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::msg::Derived_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::msg::Derived_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::msg::Derived_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<plansys2_msgs::msg::Derived_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<plansys2_msgs::msg::Derived_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__plansys2_msgs__msg__Derived
    std::shared_ptr<plansys2_msgs::msg::Derived_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__plansys2_msgs__msg__Derived
    std::shared_ptr<plansys2_msgs::msg::Derived_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Derived_ & other) const
  {
    if (this->predicate != other.predicate) {
      return false;
    }
    if (this->preconditions != other.preconditions) {
      return false;
    }
    return true;
  }
  bool operator!=(const Derived_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Derived_

// alias to use template instance with default allocator
using Derived =
  plansys2_msgs::msg::Derived_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace plansys2_msgs

#endif  // PLANSYS2_MSGS__MSG__DETAIL__DERIVED__STRUCT_HPP_
