// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from plansys2_msgs:msg/Derived.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "plansys2_msgs/msg/derived.hpp"


#ifndef PLANSYS2_MSGS__MSG__DETAIL__DERIVED__TRAITS_HPP_
#define PLANSYS2_MSGS__MSG__DETAIL__DERIVED__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "plansys2_msgs/msg/detail/derived__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'predicate'
#include "plansys2_msgs/msg/detail/node__traits.hpp"
// Member 'preconditions'
#include "plansys2_msgs/msg/detail/tree__traits.hpp"

namespace plansys2_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Derived & msg,
  std::ostream & out)
{
  out << "{";
  // member: predicate
  {
    out << "predicate: ";
    to_flow_style_yaml(msg.predicate, out);
    out << ", ";
  }

  // member: preconditions
  {
    out << "preconditions: ";
    to_flow_style_yaml(msg.preconditions, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Derived & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: predicate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "predicate:\n";
    to_block_style_yaml(msg.predicate, out, indentation + 2);
  }

  // member: preconditions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "preconditions:\n";
    to_block_style_yaml(msg.preconditions, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Derived & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace plansys2_msgs

namespace rosidl_generator_traits
{

[[deprecated("use plansys2_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const plansys2_msgs::msg::Derived & msg,
  std::ostream & out, size_t indentation = 0)
{
  plansys2_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use plansys2_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const plansys2_msgs::msg::Derived & msg)
{
  return plansys2_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<plansys2_msgs::msg::Derived>()
{
  return "plansys2_msgs::msg::Derived";
}

template<>
inline const char * name<plansys2_msgs::msg::Derived>()
{
  return "plansys2_msgs/msg/Derived";
}

template<>
struct has_fixed_size<plansys2_msgs::msg::Derived>
  : std::integral_constant<bool, has_fixed_size<plansys2_msgs::msg::Node>::value && has_fixed_size<plansys2_msgs::msg::Tree>::value> {};

template<>
struct has_bounded_size<plansys2_msgs::msg::Derived>
  : std::integral_constant<bool, has_bounded_size<plansys2_msgs::msg::Node>::value && has_bounded_size<plansys2_msgs::msg::Tree>::value> {};

template<>
struct is_message<plansys2_msgs::msg::Derived>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PLANSYS2_MSGS__MSG__DETAIL__DERIVED__TRAITS_HPP_
